<template lang="pug">
  div(class="theme-switch")
    a(@click="switchDarkMode()")
      IconMoonStars(v-show="!isDarkMode")/
      IconSun(v-show="isDarkMode")/
      span(v-show="!isDarkMode") {{ $t('layout.header.darkModeOn') }}
      span(v-show="isDarkMode") {{ $t('layout.header.darkModeOff') }}
</template>

<script>

import IconMoonStars from '~/assets/svg/ph-moon-stars-fill.svg?inline';
import IconSun from '~/assets/svg/ph-sun-fill.svg?inline';

export default {
  components: {
    IconMoonStars,
    IconSun,
  },
  name:       "LayoutHeaderTheme",
  data() {
    return {
      isDarkMode: false
    }
  },
  beforeMount() {
    if (!('theme' in localStorage) &&
        window.matchMedia('(prefers-color-scheme: dark)').matches
    ) {
      this.isDarkMode = true;
      localStorage.theme = 'dark';
      document.documentElement.classList.add('dark');
    }

    if (('theme' in localStorage) && localStorage.theme === 'dark') {
      this.isDarkMode = true;
      document.documentElement.classList.add('dark');
    }

    if (('theme' in localStorage) && localStorage.theme === 'light') {
      this.isDarkMode = false;
      localStorage.theme = 'light';
      document.documentElement.classList.remove('dark');
    }
  },
  methods: {
    switchDarkMode() {
      if (!document.documentElement.classList.contains('dark')) {
        this.isDarkMode = true;
        localStorage.theme = 'dark';
        document.documentElement.classList.add('dark')
      } else {
        this.isDarkMode = false;
        localStorage.theme = 'light';
        document.documentElement.classList.remove('dark')
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.theme-switch {
  @apply
  inline-block
  text-gray-700
  dark:text-gray-400
  ;

  a {
    @apply cursor-pointer;

    svg {
      @apply
      w-8
      h-8
      md:w-6
      md:h-6
      py-1
      fill-current
      inline-block
      ;
    }

    span {
      @apply
      hidden
      md:inline-block
      align-middle
      text-xs
      mr-1
      ;
    }
  }
}
</style>
